#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <stdbool.h>
#include <errno.h>


char *slice(char *src, int begin, int end){

	int i;
	char* res = malloc(end - begin+1);
	res = malloc((end - begin+1)*sizeof(char));

	if (!res)
		goto exit;

	if (begin>end){
    		printf("Runtime Error: Slice begin integer %d is greater than end integer %d,", begin, end);
			goto exit;
	}

	int idx = 0;
	for (i=begin;i<end&&src[i]!='\0' ; i++){
		res[idx++] = src[i];
	}

	res[idx] = '\0';
	return res;


exit:
	free(res);
	return NULL;
}



int  length(char *src){
	return strlen(src);
}


char *concat(char *a, char *b){
	int len1 = strlen(a);
	int len2 = strlen(b);
	char *res = malloc(len1 + len2 + 1);
	if (!res)
		goto exit;

	memcpy(res, a, len1);
	memcpy(res + len1, b, len2 + 1);
	return res;



exit:
	free(res);
	return NULL;
}