List<int> map(func<int, int> f, List<int> list) {
    List<int> out; 
        
    for x in list {
        append(out, f(x));
    }
    return out;
}

List<int> filter(func<bool, int> f, List<int> list) {
    List<int> out; 
        
    for x in list {
        if (f(x)) {
            append(out, x);
        }
    }
    return out;
}

func<int, int> sum2() {
    return int lambda int x -> x+2;
}

void print_list(List<int> list) {
    for x in list {
        print(x);
    }
}

int main()
{
    /* [0, 1, 2, 3, 4] */
    List<int> my_list = range(5);

    List<int> out = map(int lambda int x -> x * 2, my_list);
    print_list(out);

    out = map(sum2(), my_list);
    print_list(out);

    out = filter(bool lambda int x -> x > 2, my_list);
    print_list(out);
    return 0;
}